## ros-humble-robotraconteur 1.2.2

=== debian/changelog ===
ros-humble-robotraconteur (1.2.2-1bookworm) bookworm; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- John Wason <wason@wasontech.com>  Mon, 02 Sep 2024 02:18:24 -0000
